/* aamc.c ghh Mon Dec  4 21:38:54 JST 2000 */
/* digital filter for TAMA modecleaner alignment */

#include "aamc.h"

extern unsigned adsum[8];
extern unsigned char adn0, adn1, adgroup, adfast;

extern int addata[8];
extern unsigned char newdata ;       /* 1 if new A/D data is ready */
extern unsigned char toofast ;
	/* 1 if new A/D data arrives when old has
	   not yet been used (A/D data arrives too fast for user) */





void __attribute__ ((interrupt_handler)) int_imia3 (void)
/* Timer 3 interrupt called at sampling frequency */
{
  ITU3.TSR.BIT.IMFA = 0;	/* clear interrupt */
  addata[0] = adsum[0] / adn0 - 2046;
  addata[1] = adsum[1] / adn0 - 2046;
  addata[2] = adsum[2] / adn0 - 2046;
  addata[3] = adsum[3] / adn0 - 2046;
  adn0 = 0;
  adsum[0] = 0;
  adsum[1] = 0;
  adsum[2] = 0;
  adsum[3] = 0;
  addata[4] = adsum[4] / adn1 - 2046;
  addata[5] = adsum[5] / adn1 - 2046;
  addata[6] = adsum[6] / adn1;
  addata[7] = adsum[7] / adn1;
  adn1 = 0;
  adsum[4] = 0;
  adsum[5] = 0;
  adsum[6] = 0;
  adsum[7] = 0;
  toofast = newdata;
  /* if the data is used, the user sets newdata=0.
     If that hasn't happened, the user is too slow, data arrives too fast */
  newdata = 1;
}

