;	GCC For the Hitachi H8/300
;	By Hitachi America Ltd and Cygnus Support
;	release F-1
; -O3
;
;   long smul (long x, int y)
;     er0        er0    r1
;
; Gerhard Heinzel TAMA 02/2001
;
	.h8300h
	.section .text
	.align 1
	.global _smul
_smul:
	sub.b	r3l,r3l    ; clear sign flag
	mov.l	er0,er0    ; test sign of x
	bge	.L3        ; if x positive
	neg	er0        ; x is negative, change sign
	not.b	r3l        ; invert flag (set)
.L3:
	mov.w	r1,r1      ; test sign of y
	bge	.L4        ; if y positive
	neg	r1         ; y is negative, invert y
	not.b	r3l        ; invert flag
.L4:
	mov.w	r0,r2      ; r2=x.lsw
	mov.w	e0,r0      ; r0=x.msw
	mulxu.w	r1,er0     ; er0=y*x.msw
	mulxu.w	r1,er2     ; er2=y*x.lsw
	mov.w	r0,e0      ; e0=(y*x.msw)lsw
	sub.w	r0,r0      ; er0=y*x.msw<<16
	add.l	er2,er0    ; er0=result
	mov.b	r3l,r3l    ; test flag
	beq	.L7        ; if 0 exit
	neg	er0        ; invert result
.L7:
	rts
	.end
